/* Gui.c generated by valac, the Vala compiler
 * generated from Gui.vala, do not modify */

/* Meiga - Lightweight and easy to use web file server for your desktop
 *
 * Copyright (C) 2009 Igalia, S.L.
 *
 * Authors:
 *
 * Igalia, S.L. <info@igalia.com>
 * Enrique Ocaña González <eocanha@igalia.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <dbus/dbus-glib-lowlevel.h>
#include <dbus/dbus-glib.h>
#include <glib/gi18n-lib.h>
#include <stdio.h>
#include <glib/gstdio.h>
#include <unistd.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <locale.h>


#define TYPE_GUI (gui_get_type ())
#define GUI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GUI, Gui))
#define GUI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GUI, GuiClass))
#define IS_GUI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GUI))
#define IS_GUI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GUI))
#define GUI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GUI, GuiClass))

typedef struct _Gui Gui;
typedef struct _GuiClass GuiClass;
typedef struct _GuiPrivate GuiPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __g_list_free_g_free0(var) ((var == NULL) ? NULL : (var = (_g_list_free_g_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define __g_list_free_g_object_unref0(var) ((var == NULL) ? NULL : (var = (_g_list_free_g_object_unref (var), NULL)))
#define _dbus_g_connection_unref0(var) ((var == NULL) ? NULL : (var = (dbus_g_connection_unref (var), NULL)))
#define __g_list_free_gtk_tree_path_free0(var) ((var == NULL) ? NULL : (var = (_g_list_free_gtk_tree_path_free (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))

struct _Gui {
	GObject parent_instance;
	GuiPrivate * priv;
};

struct _GuiClass {
	GObjectClass parent_class;
};

struct _GuiPrivate {
	GtkMenuShell* menu;
	GtkMenu* systraymenu;
	GtkWindow* top;
	GtkWindow* adddialog;
	GtkWindow* aboutdialog;
	GtkStatusIcon* systray;
	GtkMenuItem* systraymenu_restore;
	GtkVBox* topvbox;
	GtkTreeView* files;
	GtkEntry* auth_user;
	GtkEntry* auth_password;
	GtkEntry* port;
	GtkCheckButton* ssl;
	GtkComboBox* redirection_type;
	GtkEntry* ssh_host;
	GtkEntry* ssh_port;
	GtkEntry* ssh_user;
	GtkEntry* ssh_password;
	GtkButton* redirection_apply;
	GtkStatusbar* statusbar;
	GtkFileChooserButton* localdirectory;
	GtkEntry* shareas;
	GtkTextView* logtext;
	GtkClipboard* clipboard;
	GtkListStore* model;
	char* string_model;
	char* public_url;
	char* preferred_share;
	char* invitation;
	guint lastlog;
	guint pid;
	char* display;
	DBusGProxy* _remote;
};


static gpointer gui_parent_class = NULL;

#define UI_PATH "ui:" DATADIR "/meiga/ui"
GType gui_get_type (void);
#define GUI_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_GUI, GuiPrivate))
enum  {
	GUI_DUMMY_PROPERTY
};
void gui_on_top_hide (GtkWidget* widget, Gui* self);
void gui_on_systray (GtkStatusIcon* widget, Gui* self);
void gui_on_systray_menu (GtkStatusIcon* widget, guint button, guint activateTime, Gui* self);
void gui_on_restore (GtkWidget* widget, Gui* self);
static DBusGProxy* gui_get_remote (Gui* self);
static GList* gui_get_selected_shares (Gui* self);
static void _dynamic_unregister_path0 (DBusGProxy* self, const char* param1, GError** error);
static void gui_log (Gui* self, const char* msg);
static void _g_list_free_g_free (GList* self);
void gui_on_remove (GtkWidget* widget, Gui* self);
void gui_on_add (GtkWidget* widget, Gui* self);
void gui_quit (Gui* self);
void gui_on_quit (GtkWidget* widget, Gui* self);
static void _dynamic_set_auth_user1 (DBusGProxy* self, const char* param1, GError** error);
static char* _dynamic_get_auth_md5passwd2 (DBusGProxy* self, GError** error);
static void _dynamic_set_auth_md5passwd3 (DBusGProxy* self, const char* param1, GError** error);
static void _dynamic_set_port4 (DBusGProxy* self, guint param1, GError** error);
static void _dynamic_set_ssl5 (DBusGProxy* self, gboolean param1, GError** error);
static void _dynamic_set_ssh_host6 (DBusGProxy* self, const char* param1, GError** error);
static void _dynamic_set_ssh_port7 (DBusGProxy* self, const char* param1, GError** error);
static void _dynamic_set_ssh_user8 (DBusGProxy* self, const char* param1, GError** error);
static void _dynamic_set_ssh_password9 (DBusGProxy* self, const char* param1, GError** error);
static void _dynamic_set_redirection_type10 (DBusGProxy* self, gint param1, GError** error);
void gui_on_redirection_apply (GtkWidget* widget, Gui* self);
void gui_on_adddialogcancel (GtkWidget* widget, Gui* self);
static void gui_error_dialog (Gui* self, const char* msg);
static void _dynamic_register_path11 (DBusGProxy* self, const char* param1, const char* param2, GError** error);
void gui_on_adddialogok (GtkWidget* widget, Gui* self);
void gui_on_about (GtkWidget* widget, Gui* self);
void gui_on_aboutdialogclose (GtkWidget* widget, Gui* self);
void gui_on_copy_invitation (GtkWidget* widget, Gui* self);
static void _g_list_free_g_object_unref (GList* self);
static GtkMenuBar* gui_menushell_to_menubar (Gui* self, GtkMenuShell* menu);
static void _dynamic_register_gui12 (DBusGProxy* self, guint param1, const char* param2, GError** error);
void gui_on_remote_model_changed (Gui* self);
static void _gui_on_remote_model_changed_dynamic_ModelChanged0_ (DBusGProxy* _sender, gpointer self);
void _dynamic_ModelChanged1_connect (gpointer obj, const char * signal_name, GCallback handler, gpointer data);
void gui_on_remote_log_changed (Gui* self);
static void _gui_on_remote_log_changed_dynamic_LogChanged2_ (DBusGProxy* _sender, gpointer self);
void _dynamic_LogChanged3_connect (gpointer obj, const char * signal_name, GCallback handler, gpointer data);
static void gui_dbus_init (Gui* self);
static void gui_update_model (Gui* self);
static void gui_update_statusbar (Gui* self);
static void gui_nautilus_init (Gui* self);
static void gui_create_top_menu (Gui* self);
static void gui_create_systray_menu (Gui* self);
static void gui_create_top (Gui* self);
static void gui_create_adddialog (Gui* self);
static void gui_create_aboutdialog (Gui* self);
static void gui_update_log (Gui* self);
static void _gui_on_systray_gtk_status_icon_activate (GtkStatusIcon* _sender, gpointer self);
static void _gui_on_systray_menu_gtk_status_icon_popup_menu (GtkStatusIcon* _sender, guint button, guint activate_time, gpointer self);
static void gui_gui_init (Gui* self);
static void gui_update_model_from_string (Gui* self, GtkListStore* model, const char* string_model);
static char* _dynamic_get_paths_as_string13 (DBusGProxy* self, GError** error);
static gint _dynamic_get_redirection_type14 (DBusGProxy* self, GError** error);
static gint _dynamic_get_redirection_status15 (DBusGProxy* self, GError** error);
static guint _dynamic_get_port16 (DBusGProxy* self, GError** error);
static gboolean _dynamic_get_ssl17 (DBusGProxy* self, GError** error);
static char* _dynamic_get_auth_user18 (DBusGProxy* self, GError** error);
static char* _dynamic_get_auth_md5passwd19 (DBusGProxy* self, GError** error);
static char* _dynamic_get_pending_log20 (DBusGProxy* self, guint param1, GError** error);
static gint _dynamic_get_redirection_status21 (DBusGProxy* self, GError** error);
static char* _dynamic_get_public_url22 (DBusGProxy* self, GError** error);
static char* _dynamic_get_requests_stats23 (DBusGProxy* self, GError** error);
static void _g_list_free_gtk_tree_path_free (GList* self);
void gui_init (Gui* self);
static void _dynamic_shutdown24 (DBusGProxy* self, GError** error);
static void _gui_on_quit_gtk_menu_item_activate (GtkImageMenuItem* _sender, gpointer self);
static void _gui_on_add_gtk_menu_item_activate (GtkImageMenuItem* _sender, gpointer self);
static void _gui_on_remove_gtk_menu_item_activate (GtkImageMenuItem* _sender, gpointer self);
static void _gui_on_copy_invitation_gtk_menu_item_activate (GtkImageMenuItem* _sender, gpointer self);
static void _gui_on_about_gtk_menu_item_activate (GtkImageMenuItem* _sender, gpointer self);
static void _gui_on_restore_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void _gui_on_add_gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self);
static void _gui_on_remove_gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self);
static void _gui_on_copy_invitation_gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self);
static void _gui_on_redirection_apply_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _gui_on_top_hide_gtk_widget_hide (GtkWindow* _sender, gpointer self);
static gboolean _gtk_widget_hide_on_delete_gtk_widget_delete_event (GtkWindow* _sender, GdkEvent* event, gpointer self);
static void _gui_on_adddialogok_gtk_entry_activate (GtkEntry* _sender, gpointer self);
static void _gui_on_adddialogcancel_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _gui_on_adddialogok_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _gui_on_adddialogcancel_gtk_widget_hide (GtkWindow* _sender, gpointer self);
static void _gui_on_aboutdialogclose_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _gui_on_aboutdialogclose_gtk_widget_hide (GtkAboutDialog* _sender, gpointer self);
Gui* gui_new (void);
Gui* gui_construct (GType object_type);
gint gui_main (char** args, int args_length1);
static void gui_finalize (GObject* obj);
static void gui_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);



void gui_on_top_hide (GtkWidget* widget, Gui* self) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	g_object_set ((GObject*) self->priv->systraymenu_restore, "sensitive", TRUE, NULL);
}


void gui_on_systray (GtkStatusIcon* widget, Gui* self) {
	gboolean visible = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	g_object_get ((GObject*) self->priv->top, "visible", &visible, NULL);
	g_object_set ((GObject*) self->priv->top, "visible", !visible, NULL);
	g_object_set ((GObject*) self->priv->systraymenu_restore, "sensitive", visible, NULL);
}


void gui_on_systray_menu (GtkStatusIcon* widget, guint button, guint activateTime, Gui* self) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	if (button != 3) {
		gui_on_systray (widget, self);
		return;
	}
	gtk_menu_popup (self->priv->systraymenu, NULL, NULL, NULL, NULL, (guint) 0, (guint32) activateTime);
}


void gui_on_restore (GtkWidget* widget, Gui* self) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	g_object_set ((GObject*) self->priv->top, "visible", TRUE, NULL);
	g_object_set ((GObject*) self->priv->systraymenu_restore, "sensitive", FALSE, NULL);
}


static void _dynamic_unregister_path0 (DBusGProxy* self, const char* param1, GError** error) {
	dbus_g_proxy_call (self, "UnregisterPath", error, G_TYPE_STRING, param1, G_TYPE_INVALID, G_TYPE_INVALID);
	if (*error) {
		return;
	}
}


static void _g_list_free_g_free (GList* self) {
	g_list_foreach (self, (GFunc) g_free, NULL);
	g_list_free (self);
}


void gui_on_remove (GtkWidget* widget, Gui* self) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_inner_error_ = NULL;
	if (gui_get_remote (self) == NULL) {
		return;
	}
	{
		GList* share_collection;
		GList* share_it;
		share_collection = gui_get_selected_shares (self);
		for (share_it = share_collection; share_it != NULL; share_it = share_it->next) {
			char* share;
			share = g_strdup ((const char*) share_it->data);
			{
				{
					_dynamic_unregister_path0 (gui_get_remote (self), share, &_inner_error_);
					if (_inner_error_ != NULL) {
						goto __catch0_g_error;
					}
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError * e;
					e = _inner_error_;
					_inner_error_ = NULL;
					{
						char* _tmp0_;
						gui_log (self, _tmp0_ = g_strdup_printf (_ ("Remote error deleting share '%s'\n"), share));
						_g_free0 (_tmp0_);
						_g_error_free0 (e);
					}
				}
				__finally0:
				if (_inner_error_ != NULL) {
					_g_free0 (share);
					__g_list_free_g_free0 (share_collection);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
				_g_free0 (share);
			}
		}
		__g_list_free_g_free0 (share_collection);
	}
}


void gui_on_add (GtkWidget* widget, Gui* self) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	if (gui_get_remote (self) == NULL) {
		return;
	}
	g_object_set ((GObject*) self->priv->adddialog, "visible", TRUE, NULL);
}


void gui_on_quit (GtkWidget* widget, Gui* self) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	gui_quit (self);
}


static void _dynamic_set_auth_user1 (DBusGProxy* self, const char* param1, GError** error) {
	dbus_g_proxy_call (self, "SetAuthUser", error, G_TYPE_STRING, param1, G_TYPE_INVALID, G_TYPE_INVALID);
	if (*error) {
		return;
	}
}


static char* _dynamic_get_auth_md5passwd2 (DBusGProxy* self, GError** error) {
	char* result;
	dbus_g_proxy_call (self, "GetAuthMd5passwd", error, G_TYPE_INVALID, G_TYPE_STRING, &result, G_TYPE_INVALID);
	if (*error) {
		return NULL;
	}
	return result;
}


static void _dynamic_set_auth_md5passwd3 (DBusGProxy* self, const char* param1, GError** error) {
	dbus_g_proxy_call (self, "SetAuthMd5passwd", error, G_TYPE_STRING, param1, G_TYPE_INVALID, G_TYPE_INVALID);
	if (*error) {
		return;
	}
}


static void _dynamic_set_port4 (DBusGProxy* self, guint param1, GError** error) {
	dbus_g_proxy_call (self, "SetPort", error, G_TYPE_UINT, param1, G_TYPE_INVALID, G_TYPE_INVALID);
	if (*error) {
		return;
	}
}


static void _dynamic_set_ssl5 (DBusGProxy* self, gboolean param1, GError** error) {
	dbus_g_proxy_call (self, "SetSsl", error, G_TYPE_BOOLEAN, param1, G_TYPE_INVALID, G_TYPE_INVALID);
	if (*error) {
		return;
	}
}


static void _dynamic_set_ssh_host6 (DBusGProxy* self, const char* param1, GError** error) {
	dbus_g_proxy_call (self, "SetSshHost", error, G_TYPE_STRING, param1, G_TYPE_INVALID, G_TYPE_INVALID);
	if (*error) {
		return;
	}
}


static void _dynamic_set_ssh_port7 (DBusGProxy* self, const char* param1, GError** error) {
	dbus_g_proxy_call (self, "SetSshPort", error, G_TYPE_STRING, param1, G_TYPE_INVALID, G_TYPE_INVALID);
	if (*error) {
		return;
	}
}


static void _dynamic_set_ssh_user8 (DBusGProxy* self, const char* param1, GError** error) {
	dbus_g_proxy_call (self, "SetSshUser", error, G_TYPE_STRING, param1, G_TYPE_INVALID, G_TYPE_INVALID);
	if (*error) {
		return;
	}
}


static void _dynamic_set_ssh_password9 (DBusGProxy* self, const char* param1, GError** error) {
	dbus_g_proxy_call (self, "SetSshPassword", error, G_TYPE_STRING, param1, G_TYPE_INVALID, G_TYPE_INVALID);
	if (*error) {
		return;
	}
}


static void _dynamic_set_redirection_type10 (DBusGProxy* self, gint param1, GError** error) {
	dbus_g_proxy_call (self, "SetRedirectionType", error, G_TYPE_INT, param1, G_TYPE_INVALID, G_TYPE_INVALID);
	if (*error) {
		return;
	}
}


void gui_on_redirection_apply (GtkWidget* widget, Gui* self) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_inner_error_ = NULL;
	if (gui_get_remote (self) == NULL) {
		return;
	}
	{
		char* md5passwd;
		char* remote_md5passwd;
		_dynamic_set_auth_user1 (gui_get_remote (self), gtk_entry_get_text (self->priv->auth_user), &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
		md5passwd = NULL;
		if (_vala_strcmp0 (gtk_entry_get_text (self->priv->auth_password), "") == 0) {
			char* _tmp0_;
			md5passwd = (_tmp0_ = g_strdup (""), _g_free0 (md5passwd), _tmp0_);
		} else {
			char* _tmp1_;
			md5passwd = (_tmp1_ = g_compute_checksum_for_string (G_CHECKSUM_MD5, gtk_entry_get_text (self->priv->auth_password), -1), _g_free0 (md5passwd), _tmp1_);
		}
		remote_md5passwd = _dynamic_get_auth_md5passwd2 (gui_get_remote (self), &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_free0 (md5passwd);
			goto __catch1_g_error;
		}
		if (_vala_strcmp0 (md5passwd, remote_md5passwd) != 0) {
			_dynamic_set_auth_md5passwd3 (gui_get_remote (self), md5passwd, &_inner_error_);
			if (_inner_error_ != NULL) {
				_g_free0 (md5passwd);
				_g_free0 (remote_md5passwd);
				goto __catch1_g_error;
			}
			gtk_entry_set_text (self->priv->auth_password, md5passwd);
		}
		_dynamic_set_port4 (gui_get_remote (self), (guint) strtoul (gtk_entry_get_text (self->priv->port), NULL, 0), &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_free0 (md5passwd);
			_g_free0 (remote_md5passwd);
			goto __catch1_g_error;
		}
		_dynamic_set_ssl5 (gui_get_remote (self), gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->ssl), &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_free0 (md5passwd);
			_g_free0 (remote_md5passwd);
			goto __catch1_g_error;
		}
		_dynamic_set_ssh_host6 (gui_get_remote (self), gtk_entry_get_text (self->priv->ssh_host), &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_free0 (md5passwd);
			_g_free0 (remote_md5passwd);
			goto __catch1_g_error;
		}
		_dynamic_set_ssh_port7 (gui_get_remote (self), gtk_entry_get_text (self->priv->ssh_port), &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_free0 (md5passwd);
			_g_free0 (remote_md5passwd);
			goto __catch1_g_error;
		}
		_dynamic_set_ssh_user8 (gui_get_remote (self), gtk_entry_get_text (self->priv->ssh_user), &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_free0 (md5passwd);
			_g_free0 (remote_md5passwd);
			goto __catch1_g_error;
		}
		_dynamic_set_ssh_password9 (gui_get_remote (self), gtk_entry_get_text (self->priv->ssh_password), &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_free0 (md5passwd);
			_g_free0 (remote_md5passwd);
			goto __catch1_g_error;
		}
		_dynamic_set_redirection_type10 (gui_get_remote (self), gtk_combo_box_get_active (self->priv->redirection_type), &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_free0 (md5passwd);
			_g_free0 (remote_md5passwd);
			goto __catch1_g_error;
		}
		_g_free0 (md5passwd);
		_g_free0 (remote_md5passwd);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			gui_log (self, _ ("Remote error applying redirection options\n"));
			_g_error_free0 (e);
		}
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


void gui_on_adddialogcancel (GtkWidget* widget, Gui* self) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	g_object_set ((GObject*) self->priv->adddialog, "visible", FALSE, NULL);
	gtk_entry_set_text (self->priv->shareas, "");
}


static char* string_replace (const char* self, const char* old, const char* replacement) {
	char* result = NULL;
	GError * _inner_error_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	_inner_error_ = NULL;
	{
		char* _tmp0_;
		GRegex* _tmp1_;
		GRegex* regex;
		char* _tmp2_;
		regex = (_tmp1_ = g_regex_new (_tmp0_ = g_regex_escape_string (old, -1), 0, 0, &_inner_error_), _g_free0 (_tmp0_), _tmp1_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch2_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp2_ = g_regex_replace_literal (regex, self, (gssize) (-1), 0, replacement, 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch2_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = _tmp2_;
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally2;
	__catch2_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_assert_not_reached ();
			_g_error_free0 (e);
		}
	}
	__finally2:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


static void _dynamic_register_path11 (DBusGProxy* self, const char* param1, const char* param2, GError** error) {
	dbus_g_proxy_call (self, "RegisterPath", error, G_TYPE_STRING, param1, G_TYPE_STRING, param2, G_TYPE_INVALID, G_TYPE_INVALID);
	if (*error) {
		return;
	}
}


void gui_on_adddialogok (GtkWidget* widget, Gui* self) {
	GError * _inner_error_;
	char* local_file;
	char* shared_as;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	_inner_error_ = NULL;
	local_file = gtk_file_chooser_get_filename ((GtkFileChooser*) self->priv->localdirectory);
	shared_as = g_strdup (gtk_entry_get_text (self->priv->shareas));
	if (shared_as != NULL) {
		char* _tmp1_;
		gboolean _tmp2_;
		if (g_utf8_get_char (g_utf8_offset_to_pointer (shared_as, 0)) != '/') {
			char* _tmp0_;
			shared_as = (_tmp0_ = g_strconcat ("/", shared_as, NULL), _g_free0 (shared_as), _tmp0_);
		}
		if ((_tmp2_ = strcmp (_tmp1_ = string_replace (shared_as, "/", ""), "") == 0, _g_free0 (_tmp1_), _tmp2_)) {
			gui_error_dialog (self, _ ("Empty share name not allowed"));
			_g_free0 (local_file);
			_g_free0 (shared_as);
			return;
		}
		if (strcmp (shared_as, "/rss") == 0) {
			gui_error_dialog (self, _ ("Share name not allowed"));
			_g_free0 (local_file);
			_g_free0 (shared_as);
			return;
		}
	}
	if (gui_get_remote (self) != NULL) {
		{
			_dynamic_register_path11 (gui_get_remote (self), local_file, shared_as, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch3_g_error;
			}
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				char* _tmp3_;
				gui_log (self, _tmp3_ = g_strdup_printf (_ ("Remote error sharing '%s' as '%s'\n"), local_file, shared_as));
				_g_free0 (_tmp3_);
				_g_error_free0 (e);
			}
		}
		__finally3:
		if (_inner_error_ != NULL) {
			_g_free0 (local_file);
			_g_free0 (shared_as);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	gtk_entry_set_text (self->priv->shareas, "");
	g_object_set ((GObject*) self->priv->adddialog, "visible", FALSE, NULL);
	_g_free0 (local_file);
	_g_free0 (shared_as);
}


void gui_on_about (GtkWidget* widget, Gui* self) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	g_object_set ((GObject*) self->priv->aboutdialog, "visible", TRUE, NULL);
}


void gui_on_aboutdialogclose (GtkWidget* widget, Gui* self) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	g_object_set ((GObject*) self->priv->aboutdialog, "visible", FALSE, NULL);
}


void gui_on_copy_invitation (GtkWidget* widget, Gui* self) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	gtk_clipboard_set_text (self->priv->clipboard, self->priv->invitation, -1);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _g_list_free_g_object_unref (GList* self) {
	g_list_foreach (self, (GFunc) g_object_unref, NULL);
	g_list_free (self);
}


static GtkMenuBar* gui_menushell_to_menubar (Gui* self, GtkMenuShell* menu) {
	GtkMenuBar* result = NULL;
	GtkMenuBar* menubar;
	GList* children;
	GList* childrencopy;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (menu != NULL, NULL);
	menubar = g_object_ref_sink ((GtkMenuBar*) gtk_menu_bar_new ());
	children = (GList*) gtk_container_get_children (GTK_CONTAINER (menu));
	childrencopy = NULL;
	{
		GList* menuitem_collection;
		GList* menuitem_it;
		menuitem_collection = children;
		for (menuitem_it = menuitem_collection; menuitem_it != NULL; menuitem_it = menuitem_it->next) {
			GtkMenuItem* menuitem;
			menuitem = _g_object_ref0 ((GtkMenuItem*) menuitem_it->data);
			{
				childrencopy = g_list_append (childrencopy, _g_object_ref0 (menuitem));
				_g_object_unref0 (menuitem);
			}
		}
	}
	{
		GList* menuitem_collection;
		GList* menuitem_it;
		menuitem_collection = childrencopy;
		for (menuitem_it = menuitem_collection; menuitem_it != NULL; menuitem_it = menuitem_it->next) {
			GtkMenuItem* menuitem;
			menuitem = _g_object_ref0 ((GtkMenuItem*) menuitem_it->data);
			{
				gtk_container_remove (GTK_CONTAINER (gtk_widget_get_parent ((GtkWidget*) menuitem)), GTK_WIDGET (menuitem));
				gtk_menu_shell_append ((GtkMenuShell*) menubar, (GtkWidget*) menuitem);
				_g_object_unref0 (menuitem);
			}
		}
	}
	result = menubar;
	__g_list_free_g_object_unref0 (children);
	__g_list_free_g_object_unref0 (childrencopy);
	return result;
}


static void gui_error_dialog (Gui* self, const char* msg) {
	GtkMessageDialog* d;
	g_return_if_fail (self != NULL);
	g_return_if_fail (msg != NULL);
	d = g_object_ref_sink ((GtkMessageDialog*) gtk_message_dialog_new (self->priv->adddialog, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "%s", msg));
	gtk_dialog_run ((GtkDialog*) d);
	gtk_object_destroy ((GtkObject*) d);
	_g_object_unref0 (d);
}


static void gui_log (Gui* self, const char* msg) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (msg != NULL);
	if (self->priv->logtext != NULL) {
		GtkTextBuffer* b;
		GtkTextIter end = {0};
		b = _g_object_ref0 (gtk_text_view_get_buffer (self->priv->logtext));
		gtk_text_buffer_get_end_iter (b, &end);
		gtk_text_buffer_insert (gtk_text_view_get_buffer (self->priv->logtext), &end, msg, -1);
		_g_object_unref0 (b);
	} else {
		fprintf (stderr, "%s", msg);
	}
}


static void _dynamic_register_gui12 (DBusGProxy* self, guint param1, const char* param2, GError** error) {
	dbus_g_proxy_call (self, "RegisterGui", error, G_TYPE_UINT, param1, G_TYPE_STRING, param2, G_TYPE_INVALID, G_TYPE_INVALID);
	if (*error) {
		return;
	}
}


static void _gui_on_remote_model_changed_dynamic_ModelChanged0_ (DBusGProxy* _sender, gpointer self) {
	gui_on_remote_model_changed (self);
}


void _dynamic_ModelChanged1_connect (gpointer obj, const char * signal_name, GCallback handler, gpointer data) {
	dbus_g_object_register_marshaller (g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, G_TYPE_INVALID);
	dbus_g_proxy_add_signal (obj, "ModelChanged", G_TYPE_INVALID);
	dbus_g_proxy_connect_signal (obj, signal_name, handler, data, NULL);
}


static void _gui_on_remote_log_changed_dynamic_LogChanged2_ (DBusGProxy* _sender, gpointer self) {
	gui_on_remote_log_changed (self);
}


void _dynamic_LogChanged3_connect (gpointer obj, const char * signal_name, GCallback handler, gpointer data) {
	dbus_g_object_register_marshaller (g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, G_TYPE_INVALID);
	dbus_g_proxy_add_signal (obj, "LogChanged", G_TYPE_INVALID);
	dbus_g_proxy_connect_signal (obj, signal_name, handler, data, NULL);
}


static void gui_dbus_init (Gui* self) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	{
		DBusGConnection* conn;
		DBusGProxy* _tmp0_;
		conn = dbus_g_bus_get (DBUS_BUS_SESSION, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch4_g_error;
		}
		self->priv->_remote = (_tmp0_ = dbus_g_proxy_new_for_name (conn, "com.igalia.Meiga", "/com/igalia/Meiga", "com.igalia.Meiga"), _g_object_unref0 (self->priv->_remote), _tmp0_);
		_dbus_g_connection_unref0 (conn);
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			char* _tmp1_;
			gui_log (self, _tmp1_ = g_strdup_printf (_ ("Error looking for DBUS server: %s\n"), e->message));
			_g_free0 (_tmp1_);
			_g_error_free0 (e);
		}
	}
	__finally4:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	{
		if (self->priv->_remote != NULL) {
			_dynamic_register_gui12 (self->priv->_remote, self->priv->pid, self->priv->display, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch5_g_error;
			}
		}
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			DBusGProxy* _tmp2_;
			gui_log (self, _ ("Error looking for DBUS server: remote object not found\n"));
			self->priv->_remote = (_tmp2_ = NULL, _g_object_unref0 (self->priv->_remote), _tmp2_);
			_g_error_free0 (e);
		}
	}
	__finally5:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	if (self->priv->_remote != NULL) {
		_dynamic_ModelChanged1_connect (self->priv->_remote, "ModelChanged", (GCallback) _gui_on_remote_model_changed_dynamic_ModelChanged0_, self);
		_dynamic_LogChanged3_connect (self->priv->_remote, "LogChanged", (GCallback) _gui_on_remote_log_changed_dynamic_LogChanged2_, self);
	}
	gui_on_remote_model_changed (self);
}


void gui_on_remote_model_changed (Gui* self) {
	g_return_if_fail (self != NULL);
	gui_update_model (self);
	gui_update_statusbar (self);
}


static void gui_nautilus_init (Gui* self) {
	char* menudir;
	char* menulink;
	char* menufile;
	g_return_if_fail (self != NULL);
	menudir = g_strconcat (g_get_home_dir (), "/.gnome2/nautilus-scripts/", NULL);
	menulink = g_strconcat (menudir, _ ("Share on Meiga..."), NULL);
	menufile = g_strdup (DATADIR "/nautilus-scripts/" "share-on-meiga");
	if (!g_file_test (menulink, G_FILE_TEST_EXISTS)) {
		char* _tmp0_;
		gui_log (self, _tmp0_ = g_strdup_printf (_ ("Creating Nautilus context menu for Meiga %s --> %s\n"), menulink, menufile));
		_g_free0 (_tmp0_);
		g_mkdir_with_parents (menudir, 0700);
		symlink (menufile, menulink);
	}
	_g_free0 (menudir);
	_g_free0 (menulink);
	_g_free0 (menufile);
}


static void _gui_on_systray_gtk_status_icon_activate (GtkStatusIcon* _sender, gpointer self) {
	gui_on_systray (_sender, self);
}


static void _gui_on_systray_menu_gtk_status_icon_popup_menu (GtkStatusIcon* _sender, guint button, guint activate_time, gpointer self) {
	gui_on_systray_menu (_sender, button, activate_time, self);
}


static void gui_gui_init (Gui* self) {
	GError * _inner_error_;
	char** _tmp1_;
	gint _path_size_;
	gint path_length1;
	char** _tmp0_;
	char** path;
	char* iconfile;
	GtkMenuShell* _tmp5_;
	char* _tmp6_;
	char* _tmp7_;
	GtkClipboard* _tmp8_;
	GtkStatusIcon* _tmp9_;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	path = (_tmp1_ = _tmp0_ = g_strsplit (UI_PATH, ":", 8), path_length1 = _vala_array_length (_tmp0_), _path_size_ = path_length1, _tmp1_);
	iconfile = NULL;
	{
		gint i;
		i = 0;
		{
			gboolean _tmp2_;
			_tmp2_ = TRUE;
			while (TRUE) {
				char* _tmp4_;
				char* _tmp3_;
				if (!_tmp2_) {
					i++;
				}
				_tmp2_ = FALSE;
				if (!(path[i] != NULL)) {
					break;
				}
				iconfile = (_tmp4_ = g_strconcat (_tmp3_ = g_strconcat (path[i], "/", NULL), "meiga-16x16.png", NULL), _g_free0 (iconfile), _tmp4_);
				_g_free0 (_tmp3_);
				if (g_file_test (iconfile, G_FILE_TEST_IS_REGULAR)) {
					break;
				}
			}
		}
	}
	gui_create_top_menu (self);
	gui_create_systray_menu (self);
	gui_create_top (self);
	gui_create_adddialog (self);
	gui_create_aboutdialog (self);
	{
		gtk_window_set_icon_from_file (self->priv->top, iconfile, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch6_g_error;
		}
		gtk_window_set_icon_from_file (self->priv->adddialog, iconfile, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch6_g_error;
		}
		gtk_window_set_icon_from_file (self->priv->aboutdialog, iconfile, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch6_g_error;
		}
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			gui_log (self, _ ("Icon file not found\n"));
			_g_error_free0 (e);
		}
	}
	__finally6:
	if (_inner_error_ != NULL) {
		path = (_vala_array_free (path, path_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (iconfile);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	self->priv->menu = (_tmp5_ = (GtkMenuShell*) gui_menushell_to_menubar (self, self->priv->menu), _g_object_unref0 (self->priv->menu), _tmp5_);
	g_object_set ((GObject*) self->priv->menu, "visible", TRUE, NULL);
	gtk_box_pack_start ((GtkBox*) self->priv->topvbox, (GtkWidget*) self->priv->menu, FALSE, FALSE, (guint) 0);
	gtk_box_reorder_child ((GtkBox*) self->priv->topvbox, (GtkWidget*) self->priv->menu, 0);
	self->priv->pid = (guint) getpid ();
	self->priv->display = (_tmp6_ = g_strdup (g_getenv ("DISPLAY")), _g_free0 (self->priv->display), _tmp6_);
	self->priv->public_url = (_tmp7_ = g_strdup (""), _g_free0 (self->priv->public_url), _tmp7_);
	self->priv->lastlog = (guint) 0;
	self->priv->clipboard = (_tmp8_ = _g_object_ref0 (gtk_clipboard_get (GDK_SELECTION_CLIPBOARD)), _g_object_unref0 (self->priv->clipboard), _tmp8_);
	gui_update_model (self);
	gui_update_log (self);
	self->priv->systray = (_tmp9_ = gtk_status_icon_new_from_file (iconfile), _g_object_unref0 (self->priv->systray), _tmp9_);
	g_signal_connect_object (self->priv->systray, "activate", (GCallback) _gui_on_systray_gtk_status_icon_activate, self, 0);
	g_signal_connect_object (self->priv->systray, "popup-menu", (GCallback) _gui_on_systray_menu_gtk_status_icon_popup_menu, self, 0);
	g_object_set ((GObject*) self->priv->systray, "visible", TRUE, NULL);
	gui_on_restore ((GtkWidget*) self->priv->top, self);
	path = (_vala_array_free (path, path_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (iconfile);
}


static void gui_update_model_from_string (Gui* self, GtkListStore* model, const char* string_model) {
	char* _tmp0_;
	gboolean _tmp1_ = FALSE;
	char** _tmp3_;
	gint _rows_size_;
	gint rows_length1;
	char** _tmp2_;
	char** rows;
	g_return_if_fail (self != NULL);
	g_return_if_fail (model != NULL);
	g_return_if_fail (string_model != NULL);
	gtk_list_store_clear (model);
	self->priv->preferred_share = (_tmp0_ = NULL, _g_free0 (self->priv->preferred_share), _tmp0_);
	if (string_model == NULL) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = g_utf8_get_char (g_utf8_offset_to_pointer (string_model, 0)) == '\0';
	}
	if (_tmp1_) {
		return;
	}
	rows = (_tmp3_ = _tmp2_ = g_strsplit (string_model, "\n", 128), rows_length1 = _vala_array_length (_tmp2_), _rows_size_ = rows_length1, _tmp3_);
	{
		gint i;
		i = 0;
		{
			gboolean _tmp4_;
			_tmp4_ = TRUE;
			while (TRUE) {
				char** _tmp6_;
				gint _cols_size_;
				gint cols_length1;
				char** _tmp5_;
				char** cols;
				char* local_file;
				char* shared_as;
				GtkTreeIter iter = {0};
				if (!_tmp4_) {
					i++;
				}
				_tmp4_ = FALSE;
				if (!(g_utf8_get_char (g_utf8_offset_to_pointer (rows[i], 0)) != '\0')) {
					break;
				}
				cols = (_tmp6_ = _tmp5_ = g_strsplit (rows[i], "\t", 2), cols_length1 = _vala_array_length (_tmp5_), _cols_size_ = cols_length1, _tmp6_);
				local_file = g_strdup (cols[1]);
				shared_as = g_strdup (cols[0]);
				gtk_list_store_append (model, &iter);
				gtk_list_store_set (model, &iter, 0, local_file, 1, shared_as, -1);
				if (i == 0) {
					char* _tmp7_;
					self->priv->preferred_share = (_tmp7_ = g_strdup (shared_as), _g_free0 (self->priv->preferred_share), _tmp7_);
				}
				cols = (_vala_array_free (cols, cols_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (local_file);
				_g_free0 (shared_as);
			}
		}
	}
	rows = (_vala_array_free (rows, rows_length1, (GDestroyNotify) g_free), NULL);
}


static char* _dynamic_get_paths_as_string13 (DBusGProxy* self, GError** error) {
	char* result;
	dbus_g_proxy_call (self, "GetPathsAsString", error, G_TYPE_INVALID, G_TYPE_STRING, &result, G_TYPE_INVALID);
	if (*error) {
		return NULL;
	}
	return result;
}


static gint _dynamic_get_redirection_type14 (DBusGProxy* self, GError** error) {
	gint result;
	dbus_g_proxy_call (self, "GetRedirectionType", error, G_TYPE_INVALID, G_TYPE_INT, &result, G_TYPE_INVALID);
	if (*error) {
		return 0;
	}
	return result;
}


static gint _dynamic_get_redirection_status15 (DBusGProxy* self, GError** error) {
	gint result;
	dbus_g_proxy_call (self, "GetRedirectionStatus", error, G_TYPE_INVALID, G_TYPE_INT, &result, G_TYPE_INVALID);
	if (*error) {
		return 0;
	}
	return result;
}


static guint _dynamic_get_port16 (DBusGProxy* self, GError** error) {
	guint result;
	dbus_g_proxy_call (self, "GetPort", error, G_TYPE_INVALID, G_TYPE_UINT, &result, G_TYPE_INVALID);
	if (*error) {
		return 0U;
	}
	return result;
}


static gboolean _dynamic_get_ssl17 (DBusGProxy* self, GError** error) {
	gboolean result;
	dbus_g_proxy_call (self, "GetSsl", error, G_TYPE_INVALID, G_TYPE_BOOLEAN, &result, G_TYPE_INVALID);
	if (*error) {
		return FALSE;
	}
	return result;
}


static char* _dynamic_get_auth_user18 (DBusGProxy* self, GError** error) {
	char* result;
	dbus_g_proxy_call (self, "GetAuthUser", error, G_TYPE_INVALID, G_TYPE_STRING, &result, G_TYPE_INVALID);
	if (*error) {
		return NULL;
	}
	return result;
}


static char* _dynamic_get_auth_md5passwd19 (DBusGProxy* self, GError** error) {
	char* result;
	dbus_g_proxy_call (self, "GetAuthMd5passwd", error, G_TYPE_INVALID, G_TYPE_STRING, &result, G_TYPE_INVALID);
	if (*error) {
		return NULL;
	}
	return result;
}


static void gui_update_model (Gui* self) {
	GError * _inner_error_;
	gint int_redirection_status;
	gint int_redirection_type;
	guint int_port;
	gboolean bool_ssl;
	gboolean enable_redirection_options = FALSE;
	char* _tmp0_;
	char* _tmp8_;
	char* _tmp9_;
	char* _tmp10_;
	char* _tmp11_;
	char* _tmp12_;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	int_redirection_status = 1;
	int_redirection_type = 0;
	int_port = (guint) 0;
	bool_ssl = FALSE;
	self->priv->string_model = (_tmp0_ = NULL, _g_free0 (self->priv->string_model), _tmp0_);
	if (gui_get_remote (self) != NULL) {
		{
			char* _tmp1_;
			char* _tmp2_;
			_tmp1_ = _dynamic_get_paths_as_string13 (gui_get_remote (self), &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch7_g_error;
			}
			self->priv->string_model = (_tmp2_ = _tmp1_, _g_free0 (self->priv->string_model), _tmp2_);
		}
		goto __finally7;
		__catch7_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				gui_log (self, _ ("Remote error getting paths\n"));
				_g_error_free0 (e);
			}
		}
		__finally7:
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		{
			gint _tmp3_;
			gint _tmp4_;
			guint _tmp5_;
			gboolean _tmp6_;
			_tmp3_ = _dynamic_get_redirection_type14 (gui_get_remote (self), &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch8_g_error;
			}
			int_redirection_type = _tmp3_;
			_tmp4_ = _dynamic_get_redirection_status15 (gui_get_remote (self), &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch8_g_error;
			}
			int_redirection_status = _tmp4_;
			_tmp5_ = _dynamic_get_port16 (gui_get_remote (self), &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch8_g_error;
			}
			int_port = _tmp5_;
			_tmp6_ = _dynamic_get_ssl17 (gui_get_remote (self), &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch8_g_error;
			}
			bool_ssl = _tmp6_;
		}
		goto __finally8;
		__catch8_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				gui_log (self, _ ("Remote error getting redirection options\n"));
				_g_error_free0 (e);
			}
		}
		__finally8:
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	if (self->priv->string_model == NULL) {
		char* _tmp7_;
		self->priv->string_model = (_tmp7_ = g_strdup (""), _g_free0 (self->priv->string_model), _tmp7_);
	}
	gui_update_model_from_string (self, self->priv->model, self->priv->string_model);
	_tmp8_ = _dynamic_get_auth_user18 (gui_get_remote (self), &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_entry_set_text (self->priv->auth_user, _tmp9_ = _tmp8_);
	_g_free0 (_tmp9_);
	_tmp10_ = _dynamic_get_auth_md5passwd19 (gui_get_remote (self), &_inner_error_);
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_entry_set_text (self->priv->auth_password, _tmp11_ = _tmp10_);
	_g_free0 (_tmp11_);
	gtk_entry_set_text (self->priv->port, _tmp12_ = g_strdup_printf ("%u", int_port));
	_g_free0 (_tmp12_);
	gtk_toggle_button_set_active ((GtkToggleButton*) self->priv->ssl, bool_ssl);
	gtk_combo_box_set_active (self->priv->redirection_type, int_redirection_type);
	enable_redirection_options = int_redirection_status != 1;
	gtk_widget_set_sensitive ((GtkWidget*) self->priv->port, enable_redirection_options);
	gtk_widget_set_sensitive ((GtkWidget*) self->priv->ssl, enable_redirection_options);
	gtk_widget_set_sensitive ((GtkWidget*) self->priv->redirection_type, enable_redirection_options);
	gtk_widget_set_sensitive ((GtkWidget*) self->priv->ssh_host, enable_redirection_options);
	gtk_widget_set_sensitive ((GtkWidget*) self->priv->ssh_port, enable_redirection_options);
	gtk_widget_set_sensitive ((GtkWidget*) self->priv->ssh_user, enable_redirection_options);
	gtk_widget_set_sensitive ((GtkWidget*) self->priv->ssh_password, enable_redirection_options);
	gtk_widget_set_sensitive ((GtkWidget*) self->priv->redirection_apply, enable_redirection_options);
}


static char* _dynamic_get_pending_log20 (DBusGProxy* self, guint param1, GError** error) {
	char* result;
	dbus_g_proxy_call (self, "GetPendingLog", error, G_TYPE_UINT, param1, G_TYPE_INVALID, G_TYPE_STRING, &result, G_TYPE_INVALID);
	if (*error) {
		return NULL;
	}
	return result;
}


static void gui_update_log (Gui* self) {
	GError * _inner_error_;
	char* new_log_lines;
	guint j;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	new_log_lines = NULL;
	if (gui_get_remote (self) != NULL) {
		{
			char* _tmp0_;
			char* _tmp1_;
			_tmp0_ = _dynamic_get_pending_log20 (gui_get_remote (self), self->priv->lastlog, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch9_g_error;
			}
			new_log_lines = (_tmp1_ = _tmp0_, _g_free0 (new_log_lines), _tmp1_);
		}
		goto __finally9;
		__catch9_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				gui_log (self, _ ("Remote error getting log lines\n"));
				_g_error_free0 (e);
			}
		}
		__finally9:
		if (_inner_error_ != NULL) {
			_g_free0 (new_log_lines);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	if (new_log_lines == NULL) {
		char* _tmp2_;
		new_log_lines = (_tmp2_ = g_strdup (""), _g_free0 (new_log_lines), _tmp2_);
	}
	j = (guint) 0;
	{
		guint i;
		i = (guint) 0;
		{
			gboolean _tmp3_;
			_tmp3_ = TRUE;
			while (TRUE) {
				if (!_tmp3_) {
					i++;
				}
				_tmp3_ = FALSE;
				if (!(g_utf8_get_char (g_utf8_offset_to_pointer (new_log_lines, i)) != '\0')) {
					break;
				}
				if (g_utf8_get_char (g_utf8_offset_to_pointer (new_log_lines, i)) == '\n') {
					j++;
				}
			}
		}
	}
	gui_log (self, new_log_lines);
	self->priv->lastlog = self->priv->lastlog + j;
	_g_free0 (new_log_lines);
}


void gui_on_remote_log_changed (Gui* self) {
	g_return_if_fail (self != NULL);
	gui_update_log (self);
}


static gint _dynamic_get_redirection_status21 (DBusGProxy* self, GError** error) {
	gint result;
	dbus_g_proxy_call (self, "GetRedirectionStatus", error, G_TYPE_INVALID, G_TYPE_INT, &result, G_TYPE_INVALID);
	if (*error) {
		return 0;
	}
	return result;
}


static char* _dynamic_get_public_url22 (DBusGProxy* self, GError** error) {
	char* result;
	dbus_g_proxy_call (self, "GetPublicUrl", error, G_TYPE_INVALID, G_TYPE_STRING, &result, G_TYPE_INVALID);
	if (*error) {
		return NULL;
	}
	return result;
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, -1);
	return result;
}


static char* _dynamic_get_requests_stats23 (DBusGProxy* self, GError** error) {
	char* result;
	dbus_g_proxy_call (self, "GetRequestsStats", error, G_TYPE_INVALID, G_TYPE_STRING, &result, G_TYPE_INVALID);
	if (*error) {
		return NULL;
	}
	return result;
}


static void gui_update_statusbar (Gui* self) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	if (gui_get_remote (self) != NULL) {
		{
			gint status;
			char* string_status;
			char* _tmp0_;
			char* _tmp1_;
			gboolean _tmp2_ = FALSE;
			gboolean _tmp3_ = FALSE;
			char* _tmp8_;
			char* _tmp10_;
			char* _tmp9_;
			char* _tmp11_;
			char* _tmp16_;
			status = _dynamic_get_redirection_status21 (gui_get_remote (self), &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch10_g_error;
			}
			string_status = NULL;
			_tmp0_ = _dynamic_get_public_url22 (gui_get_remote (self), &_inner_error_);
			if (_inner_error_ != NULL) {
				_g_free0 (string_status);
				goto __catch10_g_error;
			}
			self->priv->public_url = (_tmp1_ = _tmp0_, _g_free0 (self->priv->public_url), _tmp1_);
			if (self->priv->public_url != NULL) {
				_tmp3_ = string_get_length (self->priv->public_url) > 0;
			} else {
				_tmp3_ = FALSE;
			}
			if (_tmp3_) {
				_tmp2_ = self->priv->preferred_share != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			if (_tmp2_) {
				char* _tmp4_;
				char* _tmp5_;
				self->priv->invitation = (_tmp4_ = g_strconcat (self->priv->public_url, self->priv->preferred_share, NULL), _g_free0 (self->priv->invitation), _tmp4_);
				string_status = (_tmp5_ = g_strdup (" - "), _g_free0 (string_status), _tmp5_);
			} else {
				char* _tmp6_;
				char* _tmp7_;
				self->priv->invitation = (_tmp6_ = g_strdup (""), _g_free0 (self->priv->invitation), _tmp6_);
				string_status = (_tmp7_ = g_strdup (""), _g_free0 (string_status), _tmp7_);
			}
			_tmp8_ = _dynamic_get_requests_stats23 (gui_get_remote (self), &_inner_error_);
			if (_inner_error_ != NULL) {
				_g_free0 (string_status);
				goto __catch10_g_error;
			}
			string_status = (_tmp10_ = g_strconcat (string_status, _tmp9_ = _tmp8_, NULL), _g_free0 (string_status), _tmp10_);
			_g_free0 (_tmp9_);
			string_status = (_tmp11_ = g_strconcat (string_status, " - ", NULL), _g_free0 (string_status), _tmp11_);
			switch (status) {
				case 0:
				{
					char* _tmp12_;
					string_status = (_tmp12_ = g_strconcat (string_status, _ ("Direct connection"), NULL), _g_free0 (string_status), _tmp12_);
					break;
				}
				case 1:
				{
					char* _tmp13_;
					string_status = (_tmp13_ = g_strconcat (string_status, _ ("Performing redirection"), NULL), _g_free0 (string_status), _tmp13_);
					break;
				}
				case 2:
				{
					char* _tmp14_;
					string_status = (_tmp14_ = g_strconcat (string_status, _ ("Redirection performed"), NULL), _g_free0 (string_status), _tmp14_);
					break;
				}
				case 3:
				{
					char* _tmp15_;
					string_status = (_tmp15_ = g_strconcat (string_status, _ ("Redirection error"), NULL), _g_free0 (string_status), _tmp15_);
					break;
				}
			}
			gtk_statusbar_pop (self->priv->statusbar, (guint) 0);
			gtk_statusbar_push (self->priv->statusbar, (guint) 0, _tmp16_ = g_strconcat (self->priv->invitation, string_status, NULL));
			_g_free0 (_tmp16_);
			_g_free0 (string_status);
		}
		goto __finally10;
		__catch10_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				gui_log (self, _ ("Remote error getting public url\n"));
				_g_error_free0 (e);
			}
		}
		__finally10:
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void _g_list_free_gtk_tree_path_free (GList* self) {
	g_list_foreach (self, (GFunc) gtk_tree_path_free, NULL);
	g_list_free (self);
}


static GList* gui_get_selected_shares (Gui* self) {
	GList* result = NULL;
	GList* selection;
	g_return_val_if_fail (self != NULL, NULL);
	selection = NULL;
	{
		GList* spath_collection;
		GList* spath_it;
		spath_collection = gtk_tree_selection_get_selected_rows (gtk_tree_view_get_selection (self->priv->files), NULL);
		for (spath_it = spath_collection; spath_it != NULL; spath_it = spath_it->next) {
			GtkTreePath* spath;
			spath = (GtkTreePath*) spath_it->data;
			{
				GtkTreeIter iter = {0};
				if (gtk_tree_model_get_iter ((GtkTreeModel*) self->priv->model, &iter, spath)) {
					char* shared_as;
					shared_as = NULL;
					gtk_tree_model_get ((GtkTreeModel*) self->priv->model, &iter, 1, &shared_as, -1, -1);
					if (shared_as != NULL) {
						selection = g_list_append (selection, g_strdup (shared_as));
					}
					_g_free0 (shared_as);
				}
			}
		}
		__g_list_free_gtk_tree_path_free0 (spath_collection);
	}
	result = selection;
	return result;
}


void gui_init (Gui* self) {
	g_return_if_fail (self != NULL);
	gui_gui_init (self);
	gui_nautilus_init (self);
}


static void _dynamic_shutdown24 (DBusGProxy* self, GError** error) {
	dbus_g_proxy_call (self, "Shutdown", error, G_TYPE_INVALID, G_TYPE_INVALID);
	if (*error) {
		return;
	}
}


void gui_quit (Gui* self) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	gtk_main_quit ();
	if (gui_get_remote (self) != NULL) {
		{
			_dynamic_shutdown24 (gui_get_remote (self), &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch11_g_error;
			}
		}
		goto __finally11;
		__catch11_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				gui_log (self, _ ("Remote error shutting down server\n"));
				_g_error_free0 (e);
			}
		}
		__finally11:
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void _gui_on_quit_gtk_menu_item_activate (GtkImageMenuItem* _sender, gpointer self) {
	gui_on_quit (_sender, self);
}


static void _gui_on_add_gtk_menu_item_activate (GtkImageMenuItem* _sender, gpointer self) {
	gui_on_add (_sender, self);
}


static void _gui_on_remove_gtk_menu_item_activate (GtkImageMenuItem* _sender, gpointer self) {
	gui_on_remove (_sender, self);
}


static void _gui_on_copy_invitation_gtk_menu_item_activate (GtkImageMenuItem* _sender, gpointer self) {
	gui_on_copy_invitation (_sender, self);
}


static void _gui_on_about_gtk_menu_item_activate (GtkImageMenuItem* _sender, gpointer self) {
	gui_on_about (_sender, self);
}


static void gui_create_top_menu (Gui* self) {
	GtkMenuShell* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->menu = (_tmp0_ = (GtkMenuShell*) g_object_ref_sink ((GtkMenu*) gtk_menu_new ()), _g_object_unref0 (self->priv->menu), _tmp0_);
	{
		GtkMenuItem* filemenu;
		GtkMenuItem* sharemenu;
		GtkMenuItem* helpmenu;
		filemenu = g_object_ref_sink ((GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("_File")));
		{
			GtkMenu* filemenumenu;
			filemenumenu = g_object_ref_sink ((GtkMenu*) gtk_menu_new ());
			{
				GtkImageMenuItem* quit;
				quit = g_object_ref_sink ((GtkImageMenuItem*) gtk_image_menu_item_new_from_stock ("gtk-quit", NULL));
				gtk_widget_show ((GtkWidget*) quit);
				gtk_container_add ((GtkContainer*) filemenumenu, (GtkWidget*) quit);
				g_signal_connect_object ((GtkMenuItem*) quit, "activate", (GCallback) _gui_on_quit_gtk_menu_item_activate, self, 0);
				_g_object_unref0 (quit);
			}
			gtk_widget_show ((GtkWidget*) filemenumenu);
			gtk_menu_item_set_submenu (filemenu, filemenumenu);
			_g_object_unref0 (filemenumenu);
		}
		gtk_widget_show ((GtkWidget*) filemenu);
		gtk_container_add ((GtkContainer*) self->priv->menu, (GtkWidget*) filemenu);
		sharemenu = g_object_ref_sink ((GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("_Share")));
		{
			GtkMenu* sharemenumenu;
			sharemenumenu = g_object_ref_sink ((GtkMenu*) gtk_menu_new ());
			{
				GtkImageMenuItem* add;
				GtkImageMenuItem* remove;
				GtkImageMenuItem* copy_invitation;
				GtkImage* _tmp1_;
				add = g_object_ref_sink ((GtkImageMenuItem*) gtk_image_menu_item_new_from_stock ("gtk-add", NULL));
				gtk_widget_show ((GtkWidget*) add);
				gtk_container_add ((GtkContainer*) sharemenumenu, (GtkWidget*) add);
				g_signal_connect_object ((GtkMenuItem*) add, "activate", (GCallback) _gui_on_add_gtk_menu_item_activate, self, 0);
				remove = g_object_ref_sink ((GtkImageMenuItem*) gtk_image_menu_item_new_from_stock ("gtk-remove", NULL));
				gtk_widget_show ((GtkWidget*) remove);
				gtk_container_add ((GtkContainer*) sharemenumenu, (GtkWidget*) remove);
				g_signal_connect_object ((GtkMenuItem*) remove, "activate", (GCallback) _gui_on_remove_gtk_menu_item_activate, self, 0);
				copy_invitation = g_object_ref_sink ((GtkImageMenuItem*) gtk_image_menu_item_new_with_mnemonic (_ ("_Copy invitation")));
				gtk_image_menu_item_set_image (copy_invitation, (GtkWidget*) (_tmp1_ = g_object_ref_sink ((GtkImage*) gtk_image_new_from_stock ("gtk-copy", GTK_ICON_SIZE_MENU))));
				_g_object_unref0 (_tmp1_);
				gtk_widget_show ((GtkWidget*) copy_invitation);
				gtk_container_add ((GtkContainer*) sharemenumenu, (GtkWidget*) copy_invitation);
				g_signal_connect_object ((GtkMenuItem*) copy_invitation, "activate", (GCallback) _gui_on_copy_invitation_gtk_menu_item_activate, self, 0);
				_g_object_unref0 (add);
				_g_object_unref0 (remove);
				_g_object_unref0 (copy_invitation);
			}
			gtk_widget_show ((GtkWidget*) sharemenumenu);
			gtk_menu_item_set_submenu (sharemenu, sharemenumenu);
			_g_object_unref0 (sharemenumenu);
		}
		gtk_widget_show ((GtkWidget*) sharemenu);
		gtk_container_add ((GtkContainer*) self->priv->menu, (GtkWidget*) sharemenu);
		helpmenu = g_object_ref_sink ((GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("_Help")));
		{
			GtkMenu* helpmenumenu;
			helpmenumenu = g_object_ref_sink ((GtkMenu*) gtk_menu_new ());
			{
				GtkImageMenuItem* about;
				about = g_object_ref_sink ((GtkImageMenuItem*) gtk_image_menu_item_new_from_stock ("gtk-about", NULL));
				gtk_widget_show ((GtkWidget*) about);
				gtk_container_add ((GtkContainer*) helpmenumenu, (GtkWidget*) about);
				g_signal_connect_object ((GtkMenuItem*) about, "activate", (GCallback) _gui_on_about_gtk_menu_item_activate, self, 0);
				_g_object_unref0 (about);
			}
			gtk_widget_show ((GtkWidget*) helpmenumenu);
			gtk_menu_item_set_submenu (helpmenu, helpmenumenu);
			_g_object_unref0 (helpmenumenu);
		}
		gtk_widget_show ((GtkWidget*) helpmenu);
		gtk_container_add ((GtkContainer*) self->priv->menu, (GtkWidget*) helpmenu);
		_g_object_unref0 (filemenu);
		_g_object_unref0 (sharemenu);
		_g_object_unref0 (helpmenu);
	}
}


static void _gui_on_restore_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	gui_on_restore (_sender, self);
}


static void gui_create_systray_menu (Gui* self) {
	GtkMenu* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->systraymenu = (_tmp0_ = g_object_ref_sink ((GtkMenu*) gtk_menu_new ()), _g_object_unref0 (self->priv->systraymenu), _tmp0_);
	{
		GtkMenuItem* _tmp1_;
		GtkSeparatorMenuItem* sep;
		GtkImageMenuItem* copy_invitation;
		GtkImage* _tmp2_;
		GtkImageMenuItem* quit;
		self->priv->systraymenu_restore = (_tmp1_ = g_object_ref_sink ((GtkMenuItem*) gtk_menu_item_new_with_mnemonic ("_Restore")), _g_object_unref0 (self->priv->systraymenu_restore), _tmp1_);
		gtk_widget_show ((GtkWidget*) self->priv->systraymenu_restore);
		gtk_container_add ((GtkContainer*) self->priv->systraymenu, (GtkWidget*) self->priv->systraymenu_restore);
		g_signal_connect_object (self->priv->systraymenu_restore, "activate", (GCallback) _gui_on_restore_gtk_menu_item_activate, self, 0);
		sep = g_object_ref_sink ((GtkSeparatorMenuItem*) gtk_separator_menu_item_new ());
		gtk_widget_show ((GtkWidget*) sep);
		gtk_container_add ((GtkContainer*) self->priv->systraymenu, (GtkWidget*) sep);
		copy_invitation = g_object_ref_sink ((GtkImageMenuItem*) gtk_image_menu_item_new_with_mnemonic (_ ("_Copy invitation")));
		gtk_image_menu_item_set_image (copy_invitation, (GtkWidget*) (_tmp2_ = g_object_ref_sink ((GtkImage*) gtk_image_new_from_stock ("gtk-copy", GTK_ICON_SIZE_MENU))));
		_g_object_unref0 (_tmp2_);
		gtk_widget_show ((GtkWidget*) copy_invitation);
		gtk_container_add ((GtkContainer*) self->priv->systraymenu, (GtkWidget*) copy_invitation);
		g_signal_connect_object ((GtkMenuItem*) copy_invitation, "activate", (GCallback) _gui_on_copy_invitation_gtk_menu_item_activate, self, 0);
		quit = g_object_ref_sink ((GtkImageMenuItem*) gtk_image_menu_item_new_from_stock ("gtk-quit", NULL));
		gtk_widget_show ((GtkWidget*) quit);
		gtk_container_add ((GtkContainer*) self->priv->systraymenu, (GtkWidget*) quit);
		g_signal_connect_object ((GtkMenuItem*) quit, "activate", (GCallback) _gui_on_quit_gtk_menu_item_activate, self, 0);
		_g_object_unref0 (sep);
		_g_object_unref0 (copy_invitation);
		_g_object_unref0 (quit);
	}
}


static void _gui_on_add_gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self) {
	gui_on_add (_sender, self);
}


static void _gui_on_remove_gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self) {
	gui_on_remove (_sender, self);
}


static void _gui_on_copy_invitation_gtk_tool_button_clicked (GtkToolButton* _sender, gpointer self) {
	gui_on_copy_invitation (_sender, self);
}


static void _gui_on_redirection_apply_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	gui_on_redirection_apply (_sender, self);
}


static void _gui_on_top_hide_gtk_widget_hide (GtkWindow* _sender, gpointer self) {
	gui_on_top_hide (_sender, self);
}


static gboolean _gtk_widget_hide_on_delete_gtk_widget_delete_event (GtkWindow* _sender, GdkEvent* event, gpointer self) {
	return gtk_widget_hide_on_delete (self);
}


static void gui_create_top (Gui* self) {
	GtkWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->top = (_tmp0_ = g_object_ref_sink ((GtkWindow*) gtk_window_new (GTK_WINDOW_TOPLEVEL)), _g_object_unref0 (self->priv->top), _tmp0_);
	gtk_window_set_title (self->priv->top, _ ("Meiga"));
	g_object_set (self->priv->top, "default-height", 400, NULL);
	g_object_set (self->priv->top, "default-width", 350, NULL);
	{
		GtkVBox* _tmp1_;
		self->priv->topvbox = (_tmp1_ = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 0)), _g_object_unref0 (self->priv->topvbox), _tmp1_);
		{
			GtkHandleBox* hb;
			GtkNotebook* nb;
			GtkStatusbar* _tmp21_;
			hb = g_object_ref_sink ((GtkHandleBox*) gtk_handle_box_new ());
			{
				GtkToolbar* tb;
				tb = g_object_ref_sink ((GtkToolbar*) gtk_toolbar_new ());
				{
					GtkToolButton* tadd;
					GtkToolButton* tremove;
					GtkToolButton* tcopy_invitation;
					tadd = g_object_ref_sink ((GtkToolButton*) gtk_tool_button_new_from_stock ("gtk-add"));
					gtk_toolbar_insert (tb, (GtkToolItem*) tadd, -1);
					gtk_widget_show ((GtkWidget*) tadd);
					g_signal_connect_object (tadd, "clicked", (GCallback) _gui_on_add_gtk_tool_button_clicked, self, 0);
					tremove = g_object_ref_sink ((GtkToolButton*) gtk_tool_button_new_from_stock ("gtk-remove"));
					gtk_toolbar_insert (tb, (GtkToolItem*) tremove, -1);
					gtk_widget_show ((GtkWidget*) tremove);
					g_signal_connect_object (tremove, "clicked", (GCallback) _gui_on_remove_gtk_tool_button_clicked, self, 0);
					tcopy_invitation = g_object_ref_sink ((GtkToolButton*) gtk_tool_button_new_from_stock ("gtk-copy"));
					gtk_toolbar_insert (tb, (GtkToolItem*) tcopy_invitation, -1);
					gtk_widget_show ((GtkWidget*) tcopy_invitation);
					g_signal_connect_object (tcopy_invitation, "clicked", (GCallback) _gui_on_copy_invitation_gtk_tool_button_clicked, self, 0);
					_g_object_unref0 (tadd);
					_g_object_unref0 (tremove);
					_g_object_unref0 (tcopy_invitation);
				}
				gtk_container_add ((GtkContainer*) hb, (GtkWidget*) tb);
				gtk_widget_show ((GtkWidget*) tb);
				_g_object_unref0 (tb);
			}
			nb = g_object_ref_sink ((GtkNotebook*) gtk_notebook_new ());
			{
				GtkScrolledWindow* sw1;
				GtkLabel* _tmp6_;
				GtkScrolledWindow* sw2;
				GtkLabel* _tmp8_;
				GtkScrolledWindow* sw3;
				GtkLabel* _tmp20_;
				sw1 = g_object_ref_sink ((GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL));
				{
					GtkTreeView* _tmp2_;
					GtkListStore* _tmp3_;
					GtkCellRendererText* _tmp4_;
					GtkCellRendererText* _tmp5_;
					self->priv->files = (_tmp2_ = g_object_ref_sink ((GtkTreeView*) gtk_tree_view_new ()), _g_object_unref0 (self->priv->files), _tmp2_);
					gtk_container_add ((GtkContainer*) sw1, (GtkWidget*) self->priv->files);
					gtk_widget_show ((GtkWidget*) self->priv->files);
					self->priv->model = (_tmp3_ = gtk_list_store_new (2, G_TYPE_STRING, G_TYPE_STRING, NULL), _g_object_unref0 (self->priv->model), _tmp3_);
					gtk_tree_view_set_model (self->priv->files, (GtkTreeModel*) self->priv->model);
					gtk_tree_view_insert_column_with_attributes (self->priv->files, -1, _ ("Local file"), (GtkCellRenderer*) (_tmp4_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ())), "text", 0, NULL, NULL);
					_g_object_unref0 (_tmp4_);
					gtk_tree_view_insert_column_with_attributes (self->priv->files, -1, _ ("Shared as"), (GtkCellRenderer*) (_tmp5_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ())), "text", 1, NULL, NULL);
					_g_object_unref0 (_tmp5_);
					gtk_tree_selection_set_mode (gtk_tree_view_get_selection (self->priv->files), GTK_SELECTION_MULTIPLE);
				}
				g_object_set (sw1, "vscrollbar-policy", GTK_POLICY_AUTOMATIC, NULL);
				g_object_set (sw1, "hscrollbar-policy", GTK_POLICY_AUTOMATIC, NULL);
				gtk_scrolled_window_set_shadow_type (sw1, GTK_SHADOW_IN);
				gtk_notebook_append_page (nb, (GtkWidget*) sw1, (GtkWidget*) (_tmp6_ = g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("Shares")))));
				_g_object_unref0 (_tmp6_);
				gtk_widget_show ((GtkWidget*) sw1);
				sw2 = g_object_ref_sink ((GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL));
				{
					GtkTextView* _tmp7_;
					self->priv->logtext = (_tmp7_ = g_object_ref_sink ((GtkTextView*) gtk_text_view_new ()), _g_object_unref0 (self->priv->logtext), _tmp7_);
					gtk_text_view_set_editable (self->priv->logtext, FALSE);
					gtk_text_view_set_left_margin (self->priv->logtext, 5);
					gtk_text_view_set_right_margin (self->priv->logtext, 5);
					gtk_text_view_set_cursor_visible (self->priv->logtext, FALSE);
					gtk_container_add ((GtkContainer*) sw2, (GtkWidget*) self->priv->logtext);
					gtk_widget_show ((GtkWidget*) self->priv->logtext);
				}
				g_object_set (sw2, "vscrollbar-policy", GTK_POLICY_AUTOMATIC, NULL);
				g_object_set (sw2, "hscrollbar-policy", GTK_POLICY_AUTOMATIC, NULL);
				gtk_scrolled_window_set_shadow_type (sw2, GTK_SHADOW_IN);
				gtk_notebook_append_page (nb, (GtkWidget*) sw2, (GtkWidget*) (_tmp8_ = g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("Log")))));
				_g_object_unref0 (_tmp8_);
				gtk_widget_show ((GtkWidget*) sw2);
				sw3 = g_object_ref_sink ((GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL));
				{
					GtkVBox* vb;
					vb = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 0));
					{
						GtkHBox* hb2;
						GtkHBox* hb3;
						GtkHBox* hb4;
						GtkHBox* hb5;
						GtkHBox* hb6;
						GtkFrame* f;
						GtkButton* _tmp19_;
						hb2 = g_object_ref_sink ((GtkHBox*) gtk_hbox_new (FALSE, 0));
						{
							GtkLabel* l;
							GtkEntry* _tmp9_;
							l = g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("User")));
							gtk_box_pack_start ((GtkBox*) hb2, (GtkWidget*) l, FALSE, FALSE, (guint) 5);
							gtk_widget_show ((GtkWidget*) l);
							self->priv->auth_user = (_tmp9_ = g_object_ref_sink ((GtkEntry*) gtk_entry_new ()), _g_object_unref0 (self->priv->auth_user), _tmp9_);
							gtk_box_pack_start ((GtkBox*) hb2, (GtkWidget*) self->priv->auth_user, TRUE, TRUE, (guint) 5);
							gtk_widget_show ((GtkWidget*) self->priv->auth_user);
							_g_object_unref0 (l);
						}
						gtk_box_pack_start ((GtkBox*) vb, (GtkWidget*) hb2, FALSE, FALSE, (guint) 5);
						gtk_widget_show ((GtkWidget*) hb2);
						hb3 = g_object_ref_sink ((GtkHBox*) gtk_hbox_new (FALSE, 0));
						{
							GtkLabel* l;
							GtkEntry* _tmp10_;
							l = g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("Password")));
							gtk_box_pack_start ((GtkBox*) hb3, (GtkWidget*) l, FALSE, FALSE, (guint) 5);
							gtk_widget_show ((GtkWidget*) l);
							self->priv->auth_password = (_tmp10_ = g_object_ref_sink ((GtkEntry*) gtk_entry_new ()), _g_object_unref0 (self->priv->auth_password), _tmp10_);
							gtk_entry_set_visibility (self->priv->auth_password, FALSE);
							gtk_box_pack_start ((GtkBox*) hb3, (GtkWidget*) self->priv->auth_password, TRUE, TRUE, (guint) 5);
							gtk_widget_show ((GtkWidget*) self->priv->auth_password);
							_g_object_unref0 (l);
						}
						gtk_box_pack_start ((GtkBox*) vb, (GtkWidget*) hb3, FALSE, FALSE, (guint) 5);
						gtk_widget_show ((GtkWidget*) hb3);
						hb4 = g_object_ref_sink ((GtkHBox*) gtk_hbox_new (FALSE, 0));
						{
							GtkLabel* l;
							GtkEntry* _tmp11_;
							l = g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("Port")));
							gtk_box_pack_start ((GtkBox*) hb4, (GtkWidget*) l, FALSE, FALSE, (guint) 5);
							gtk_widget_show ((GtkWidget*) l);
							self->priv->port = (_tmp11_ = g_object_ref_sink ((GtkEntry*) gtk_entry_new ()), _g_object_unref0 (self->priv->port), _tmp11_);
							gtk_box_pack_start ((GtkBox*) hb4, (GtkWidget*) self->priv->port, TRUE, TRUE, (guint) 5);
							gtk_widget_show ((GtkWidget*) self->priv->port);
							_g_object_unref0 (l);
						}
						gtk_box_pack_start ((GtkBox*) vb, (GtkWidget*) hb4, FALSE, FALSE, (guint) 5);
						gtk_widget_show ((GtkWidget*) hb4);
						hb5 = g_object_ref_sink ((GtkHBox*) gtk_hbox_new (FALSE, 0));
						{
							GtkLabel* l;
							GtkCheckButton* _tmp12_;
							l = g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("Encrypt transmission")));
							gtk_box_pack_start ((GtkBox*) hb5, (GtkWidget*) l, FALSE, FALSE, (guint) 5);
							gtk_widget_show ((GtkWidget*) l);
							self->priv->ssl = (_tmp12_ = g_object_ref_sink ((GtkCheckButton*) gtk_check_button_new ()), _g_object_unref0 (self->priv->ssl), _tmp12_);
							gtk_box_pack_start ((GtkBox*) hb5, (GtkWidget*) self->priv->ssl, FALSE, FALSE, (guint) 5);
							gtk_widget_show ((GtkWidget*) self->priv->ssl);
							_g_object_unref0 (l);
						}
						gtk_box_pack_start ((GtkBox*) vb, (GtkWidget*) hb5, FALSE, FALSE, (guint) 5);
						gtk_widget_show ((GtkWidget*) hb5);
						hb6 = g_object_ref_sink ((GtkHBox*) gtk_hbox_new (FALSE, 0));
						{
							GtkLabel* l;
							GtkComboBox* _tmp13_;
							GtkListStore* redirection_type_model;
							GtkTreeIter redirection_type_model_iter = {0};
							GtkCellRenderer* redirection_type_model_cell_renderer;
							GtkCellRenderer* _tmp14_;
							l = g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("Port redirection scheme")));
							gtk_box_pack_start ((GtkBox*) hb6, (GtkWidget*) l, FALSE, FALSE, (guint) 5);
							gtk_widget_show ((GtkWidget*) l);
							self->priv->redirection_type = (_tmp13_ = g_object_ref_sink ((GtkComboBox*) gtk_combo_box_new ()), _g_object_unref0 (self->priv->redirection_type), _tmp13_);
							gtk_box_pack_start ((GtkBox*) hb6, (GtkWidget*) self->priv->redirection_type, TRUE, TRUE, (guint) 5);
							gtk_widget_show ((GtkWidget*) self->priv->redirection_type);
							redirection_type_model = gtk_list_store_new (1, G_TYPE_STRING, NULL);
							redirection_type_model_cell_renderer = NULL;
							gtk_combo_box_set_model (self->priv->redirection_type, (GtkTreeModel*) redirection_type_model);
							gtk_list_store_append (redirection_type_model, &redirection_type_model_iter);
							gtk_list_store_set (redirection_type_model, &redirection_type_model_iter, 0, _ ("None"), -1, -1);
							gtk_list_store_append (redirection_type_model, &redirection_type_model_iter);
							gtk_list_store_set (redirection_type_model, &redirection_type_model_iter, 0, _ ("UPnP"), -1, -1);
							gtk_list_store_append (redirection_type_model, &redirection_type_model_iter);
							gtk_list_store_set (redirection_type_model, &redirection_type_model_iter, 0, _ ("SSH"), -1, -1);
							gtk_list_store_append (redirection_type_model, &redirection_type_model_iter);
							gtk_list_store_set (redirection_type_model, &redirection_type_model_iter, 0, _ ("FON"), -1, -1);
							redirection_type_model_cell_renderer = (_tmp14_ = (GtkCellRenderer*) g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), _g_object_unref0 (redirection_type_model_cell_renderer), _tmp14_);
							gtk_cell_layout_pack_start ((GtkCellLayout*) self->priv->redirection_type, redirection_type_model_cell_renderer, TRUE);
							gtk_cell_layout_set_attributes ((GtkCellLayout*) self->priv->redirection_type, redirection_type_model_cell_renderer, "text", 0, NULL);
							_g_object_unref0 (l);
							_g_object_unref0 (redirection_type_model);
							_g_object_unref0 (redirection_type_model_cell_renderer);
						}
						gtk_box_pack_start ((GtkBox*) vb, (GtkWidget*) hb6, FALSE, FALSE, (guint) 5);
						gtk_widget_show ((GtkWidget*) hb6);
						f = g_object_ref_sink ((GtkFrame*) gtk_frame_new (_ ("<b>SSH options</b>")));
						gtk_label_set_use_markup (GTK_LABEL (gtk_frame_get_label_widget (f)), TRUE);
						{
							GtkAlignment* ga;
							ga = g_object_ref_sink ((GtkAlignment*) gtk_alignment_new ((float) 0.5, (float) 0.5, (float) 1.0, (float) 1.0));
							{
								GtkTable* t;
								t = g_object_ref_sink ((GtkTable*) gtk_table_new ((guint) 4, (guint) 2, FALSE));
								{
									GtkLabel* lh;
									GtkEntry* _tmp15_;
									GtkLabel* lp;
									GtkEntry* _tmp16_;
									GtkLabel* lu;
									GtkEntry* _tmp17_;
									GtkLabel* lpw;
									GtkEntry* _tmp18_;
									lh = g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("Host")));
									g_object_set ((GtkMisc*) lh, "xalign", (float) 0.0, NULL);
									gtk_table_attach (t, (GtkWidget*) lh, (guint) 0, (guint) 1, (guint) 0, (guint) 1, GTK_FILL, GTK_EXPAND | GTK_FILL, (guint) 3, (guint) 3);
									gtk_widget_show ((GtkWidget*) lh);
									self->priv->ssh_host = (_tmp15_ = g_object_ref_sink ((GtkEntry*) gtk_entry_new ()), _g_object_unref0 (self->priv->ssh_host), _tmp15_);
									gtk_table_attach (t, (GtkWidget*) self->priv->ssh_host, (guint) 1, (guint) 2, (guint) 0, (guint) 1, GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, (guint) 3, (guint) 3);
									gtk_widget_show ((GtkWidget*) self->priv->ssh_host);
									lp = g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("Port")));
									g_object_set ((GtkMisc*) lp, "xalign", (float) 0.0, NULL);
									gtk_table_attach (t, (GtkWidget*) lp, (guint) 0, (guint) 1, (guint) 1, (guint) 2, GTK_FILL, GTK_EXPAND | GTK_FILL, (guint) 3, (guint) 3);
									gtk_widget_show ((GtkWidget*) lp);
									self->priv->ssh_port = (_tmp16_ = g_object_ref_sink ((GtkEntry*) gtk_entry_new ()), _g_object_unref0 (self->priv->ssh_port), _tmp16_);
									gtk_table_attach (t, (GtkWidget*) self->priv->ssh_port, (guint) 1, (guint) 2, (guint) 1, (guint) 2, GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, (guint) 3, (guint) 3);
									gtk_widget_show ((GtkWidget*) self->priv->ssh_port);
									lu = g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("User")));
									g_object_set ((GtkMisc*) lu, "xalign", (float) 0.0, NULL);
									gtk_table_attach (t, (GtkWidget*) lu, (guint) 0, (guint) 1, (guint) 2, (guint) 3, GTK_FILL, GTK_EXPAND | GTK_FILL, (guint) 3, (guint) 3);
									gtk_widget_show ((GtkWidget*) lu);
									self->priv->ssh_user = (_tmp17_ = g_object_ref_sink ((GtkEntry*) gtk_entry_new ()), _g_object_unref0 (self->priv->ssh_user), _tmp17_);
									gtk_table_attach (t, (GtkWidget*) self->priv->ssh_user, (guint) 1, (guint) 2, (guint) 2, (guint) 3, GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, (guint) 3, (guint) 3);
									gtk_widget_show ((GtkWidget*) self->priv->ssh_user);
									lpw = g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("Password")));
									g_object_set ((GtkMisc*) lpw, "xalign", (float) 0.0, NULL);
									gtk_table_attach (t, (GtkWidget*) lpw, (guint) 0, (guint) 1, (guint) 3, (guint) 4, GTK_FILL, GTK_EXPAND | GTK_FILL, (guint) 3, (guint) 3);
									gtk_widget_show ((GtkWidget*) lpw);
									self->priv->ssh_password = (_tmp18_ = g_object_ref_sink ((GtkEntry*) gtk_entry_new ()), _g_object_unref0 (self->priv->ssh_password), _tmp18_);
									gtk_table_attach (t, (GtkWidget*) self->priv->ssh_password, (guint) 1, (guint) 2, (guint) 3, (guint) 4, GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, (guint) 3, (guint) 3);
									gtk_entry_set_visibility (self->priv->ssh_password, FALSE);
									gtk_entry_set_invisible_char (self->priv->ssh_password, (guint) '*');
									gtk_widget_show ((GtkWidget*) self->priv->ssh_password);
									_g_object_unref0 (lh);
									_g_object_unref0 (lp);
									_g_object_unref0 (lu);
									_g_object_unref0 (lpw);
								}
								gtk_table_set_col_spacings (t, (guint) 5);
								gtk_table_set_row_spacings (t, (guint) 5);
								gtk_container_add ((GtkContainer*) ga, (GtkWidget*) t);
								gtk_widget_show ((GtkWidget*) t);
								_g_object_unref0 (t);
							}
							gtk_container_add ((GtkContainer*) f, (GtkWidget*) ga);
							gtk_widget_show ((GtkWidget*) ga);
							_g_object_unref0 (ga);
						}
						gtk_frame_set_shadow_type (f, GTK_SHADOW_NONE);
						gtk_box_pack_start ((GtkBox*) vb, (GtkWidget*) f, FALSE, FALSE, (guint) 5);
						gtk_widget_show ((GtkWidget*) f);
						self->priv->redirection_apply = (_tmp19_ = g_object_ref_sink ((GtkButton*) gtk_button_new_from_stock ("gtk-apply")), _g_object_unref0 (self->priv->redirection_apply), _tmp19_);
						gtk_box_pack_start ((GtkBox*) vb, (GtkWidget*) self->priv->redirection_apply, FALSE, FALSE, (guint) 5);
						gtk_widget_show ((GtkWidget*) self->priv->redirection_apply);
						g_signal_connect_object (self->priv->redirection_apply, "clicked", (GCallback) _gui_on_redirection_apply_gtk_button_clicked, self, 0);
						_g_object_unref0 (hb2);
						_g_object_unref0 (hb3);
						_g_object_unref0 (hb4);
						_g_object_unref0 (hb5);
						_g_object_unref0 (hb6);
						_g_object_unref0 (f);
					}
					gtk_scrolled_window_add_with_viewport (sw3, (GtkWidget*) vb);
					gtk_widget_show ((GtkWidget*) vb);
					_g_object_unref0 (vb);
				}
				g_object_set (sw3, "vscrollbar-policy", GTK_POLICY_AUTOMATIC, NULL);
				g_object_set (sw3, "hscrollbar-policy", GTK_POLICY_AUTOMATIC, NULL);
				gtk_scrolled_window_set_shadow_type (sw3, GTK_SHADOW_NONE);
				gtk_notebook_append_page (nb, (GtkWidget*) sw3, (GtkWidget*) (_tmp20_ = g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("Options")))));
				_g_object_unref0 (_tmp20_);
				gtk_widget_show ((GtkWidget*) sw3);
				_g_object_unref0 (sw1);
				_g_object_unref0 (sw2);
				_g_object_unref0 (sw3);
			}
			self->priv->statusbar = (_tmp21_ = g_object_ref_sink ((GtkStatusbar*) gtk_statusbar_new ()), _g_object_unref0 (self->priv->statusbar), _tmp21_);
			gtk_box_pack_start ((GtkBox*) self->priv->topvbox, (GtkWidget*) hb, FALSE, FALSE, (guint) 0);
			gtk_widget_show ((GtkWidget*) hb);
			gtk_notebook_set_tab_pos (nb, GTK_POS_BOTTOM);
			gtk_box_pack_start ((GtkBox*) self->priv->topvbox, (GtkWidget*) nb, TRUE, TRUE, (guint) 0);
			gtk_widget_show ((GtkWidget*) nb);
			gtk_box_pack_start ((GtkBox*) self->priv->topvbox, (GtkWidget*) self->priv->statusbar, FALSE, FALSE, (guint) 0);
			gtk_widget_show ((GtkWidget*) self->priv->statusbar);
			_g_object_unref0 (hb);
			_g_object_unref0 (nb);
		}
		gtk_container_add ((GtkContainer*) self->priv->top, (GtkWidget*) self->priv->topvbox);
		gtk_widget_show ((GtkWidget*) self->priv->topvbox);
	}
	g_signal_connect_object ((GtkWidget*) self->priv->top, "hide", (GCallback) _gui_on_top_hide_gtk_widget_hide, self, 0);
	g_signal_connect_object ((GtkWidget*) self->priv->top, "delete-event", (GCallback) _gtk_widget_hide_on_delete_gtk_widget_delete_event, (GtkWidget*) self->priv->top, 0);
	gtk_widget_show ((GtkWidget*) self->priv->top);
}


static void _gui_on_adddialogok_gtk_entry_activate (GtkEntry* _sender, gpointer self) {
	gui_on_adddialogok (_sender, self);
}


static void _gui_on_adddialogcancel_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	gui_on_adddialogcancel (_sender, self);
}


static void _gui_on_adddialogok_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	gui_on_adddialogok (_sender, self);
}


static void _gui_on_adddialogcancel_gtk_widget_hide (GtkWindow* _sender, gpointer self) {
	gui_on_adddialogcancel (_sender, self);
}


static void gui_create_adddialog (Gui* self) {
	GtkWindow* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->adddialog = (_tmp0_ = (GtkWindow*) g_object_ref_sink ((GtkDialog*) gtk_dialog_new ()), _g_object_unref0 (self->priv->adddialog), _tmp0_);
	gtk_window_set_title (self->priv->adddialog, _ ("Add path"));
	gtk_window_set_modal (self->priv->adddialog, TRUE);
	gtk_window_set_type_hint (self->priv->adddialog, GDK_WINDOW_TYPE_HINT_DIALOG);
	gtk_window_set_position (self->priv->adddialog, GTK_WIN_POS_CENTER);
	{
		GtkContainer* content_area;
		GtkAlignment* ga;
		GtkContainer* action_area;
		GtkButton* c;
		GtkButton* a;
		content_area = _g_object_ref0 (GTK_CONTAINER (gtk_dialog_get_content_area (GTK_DIALOG (self->priv->adddialog))));
		ga = g_object_ref_sink ((GtkAlignment*) gtk_alignment_new ((float) 0.5, (float) 0.5, (float) 1.0, (float) 1.0));
		{
			GtkTable* t;
			t = g_object_ref_sink ((GtkTable*) gtk_table_new ((guint) 2, (guint) 2, FALSE));
			{
				GtkLabel* ld;
				GtkFileChooserButton* _tmp1_;
				GtkLabel* ls;
				GtkEntry* _tmp2_;
				ld = g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("Local directory")));
				g_object_set ((GtkMisc*) ld, "xalign", (float) 0.0, NULL);
				gtk_table_attach (t, (GtkWidget*) ld, (guint) 0, (guint) 1, (guint) 0, (guint) 1, GTK_FILL, GTK_EXPAND | GTK_FILL, (guint) 3, (guint) 3);
				gtk_widget_show ((GtkWidget*) ld);
				self->priv->localdirectory = (_tmp1_ = g_object_ref_sink ((GtkFileChooserButton*) gtk_file_chooser_button_new (_ ("Select a folder to share"), GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER)), _g_object_unref0 (self->priv->localdirectory), _tmp1_);
				gtk_table_attach (t, (GtkWidget*) self->priv->localdirectory, (guint) 1, (guint) 2, (guint) 0, (guint) 1, GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, (guint) 3, (guint) 3);
				gtk_widget_show ((GtkWidget*) self->priv->localdirectory);
				ls = g_object_ref_sink ((GtkLabel*) gtk_label_new (_ ("Share as")));
				g_object_set ((GtkMisc*) ls, "xalign", (float) 0.0, NULL);
				gtk_table_attach (t, (GtkWidget*) ls, (guint) 0, (guint) 1, (guint) 1, (guint) 2, GTK_FILL, GTK_EXPAND | GTK_FILL, (guint) 3, (guint) 3);
				gtk_widget_show ((GtkWidget*) ls);
				self->priv->shareas = (_tmp2_ = g_object_ref_sink ((GtkEntry*) gtk_entry_new ()), _g_object_unref0 (self->priv->shareas), _tmp2_);
				gtk_table_attach (t, (GtkWidget*) self->priv->shareas, (guint) 1, (guint) 2, (guint) 1, (guint) 2, GTK_EXPAND | GTK_FILL, GTK_EXPAND | GTK_FILL, (guint) 3, (guint) 3);
				g_signal_connect_object (self->priv->shareas, "activate", (GCallback) _gui_on_adddialogok_gtk_entry_activate, self, 0);
				gtk_widget_show ((GtkWidget*) self->priv->shareas);
				_g_object_unref0 (ld);
				_g_object_unref0 (ls);
			}
			gtk_table_set_col_spacings (t, (guint) 5);
			gtk_table_set_row_spacings (t, (guint) 5);
			gtk_container_add ((GtkContainer*) ga, (GtkWidget*) t);
			gtk_widget_show ((GtkWidget*) t);
			_g_object_unref0 (t);
		}
		gtk_container_add (content_area, (GtkWidget*) ga);
		gtk_widget_show ((GtkWidget*) ga);
		action_area = _g_object_ref0 (GTK_CONTAINER (gtk_dialog_get_action_area (GTK_DIALOG (self->priv->adddialog))));
		c = g_object_ref_sink ((GtkButton*) gtk_button_new_from_stock ("gtk-cancel"));
		gtk_container_add (action_area, (GtkWidget*) c);
		gtk_widget_show ((GtkWidget*) c);
		g_signal_connect_object (c, "clicked", (GCallback) _gui_on_adddialogcancel_gtk_button_clicked, self, 0);
		a = g_object_ref_sink ((GtkButton*) gtk_button_new_from_stock ("gtk-ok"));
		gtk_container_add (action_area, (GtkWidget*) a);
		gtk_widget_show ((GtkWidget*) a);
		g_signal_connect_object (a, "clicked", (GCallback) _gui_on_adddialogok_gtk_button_clicked, self, 0);
		_g_object_unref0 (content_area);
		_g_object_unref0 (ga);
		_g_object_unref0 (action_area);
		_g_object_unref0 (c);
		_g_object_unref0 (a);
	}
	g_signal_connect_object ((GtkWidget*) self->priv->adddialog, "hide", (GCallback) _gui_on_adddialogcancel_gtk_widget_hide, self, 0);
	g_signal_connect_object ((GtkWidget*) self->priv->adddialog, "delete-event", (GCallback) _gtk_widget_hide_on_delete_gtk_widget_delete_event, (GtkWidget*) self->priv->adddialog, 0);
}


static void _gui_on_aboutdialogclose_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	gui_on_aboutdialogclose (_sender, self);
}


static void _gui_on_aboutdialogclose_gtk_widget_hide (GtkAboutDialog* _sender, gpointer self) {
	gui_on_aboutdialogclose (_sender, self);
}


static void gui_create_aboutdialog (Gui* self) {
	GtkAboutDialog* a;
	GtkWindow* _tmp0_;
	char* _tmp9_;
	char* _tmp8_;
	char* _tmp7_;
	char* _tmp6_;
	char* _tmp5_;
	char* _tmp4_;
	char* _tmp3_;
	char* _tmp2_;
	char* _tmp1_;
	GList* blist;
	GtkButton* b;
	g_return_if_fail (self != NULL);
	a = g_object_ref_sink ((GtkAboutDialog*) gtk_about_dialog_new ());
	self->priv->aboutdialog = (_tmp0_ = _g_object_ref0 ((GtkWindow*) a), _g_object_unref0 (self->priv->aboutdialog), _tmp0_);
	gtk_about_dialog_set_program_name (a, _ ("Meiga"));
	gtk_about_dialog_set_version (a, VERSION);
	gtk_about_dialog_set_copyright (a, "(C) 2009 Igalia, S.L.");
	gtk_about_dialog_set_license (a, _tmp9_ = g_strconcat (_tmp8_ = g_strconcat (_tmp7_ = g_strconcat (_tmp6_ = g_strconcat (_tmp5_ = g_strconcat (_tmp4_ = g_strconcat (_tmp3_ = g_strconcat (_tmp2_ = g_strconcat (_tmp1_ = g_strconcat (_ ("This program comes with ABSOLUTELY NO WARRANTY.\n"), _ ("Licensed under GNU GPL 2.0. This is free software, and you are welcome" \
" to "), NULL), _ ("redistribute it under certain conditions.\n"), NULL), "\n", NULL), _ ("For more information, see:\n"), NULL), "\n", NULL), "http://www.gnu.org/licenses/old-licenses/gpl-2.0.html\n", NULL), "\n", NULL), _ ("Xunta de Galicia partially funded this project using "), NULL), _ ("the European Regional Development Fund (ERDF)\n"), NULL));
	_g_free0 (_tmp9_);
	_g_free0 (_tmp8_);
	_g_free0 (_tmp7_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp2_);
	_g_free0 (_tmp1_);
	gtk_about_dialog_set_website (a, "http://meiga.igalia.com");
	gtk_window_set_modal ((GtkWindow*) a, TRUE);
	gtk_window_set_type_hint ((GtkWindow*) a, GDK_WINDOW_TYPE_HINT_DIALOG);
	gtk_window_set_position ((GtkWindow*) a, GTK_WIN_POS_CENTER);
	g_object_set ((GtkWindow*) a, "default-height", 300, NULL);
	g_object_set ((GtkWindow*) a, "default-width", 300, NULL);
	blist = gtk_container_get_children (GTK_CONTAINER (gtk_dialog_get_action_area ((GtkDialog*) a)));
	b = _g_object_ref0 (GTK_BUTTON (g_list_last (blist)->data));
	g_signal_connect_object (b, "clicked", (GCallback) _gui_on_aboutdialogclose_gtk_button_clicked, self, 0);
	g_signal_connect_object ((GtkWidget*) a, "hide", (GCallback) _gui_on_aboutdialogclose_gtk_widget_hide, self, 0);
	g_signal_connect_object ((GtkWidget*) a, "delete-event", (GCallback) _gtk_widget_hide_on_delete_gtk_widget_delete_event, (GtkWidget*) a, 0);
	_g_object_unref0 (a);
	_g_list_free0 (blist);
	_g_object_unref0 (b);
}


gint gui_main (char** args, int args_length1) {
	gint result = 0;
	Gui* gui;
	setlocale (LC_ALL, "");
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
	gui = gui_new ();
	gtk_init (&args_length1, &args);
	gui_init (gui);
	gtk_main ();
	result = 0;
	_g_object_unref0 (gui);
	return result;
}


int main (int argc, char ** argv) {
	g_thread_init (NULL);
	g_type_init ();
	return gui_main (argv, argc);
}


Gui* gui_construct (GType object_type) {
	Gui * self;
	self = (Gui*) g_object_new (object_type, NULL);
	return self;
}


Gui* gui_new (void) {
	return gui_construct (TYPE_GUI);
}


static DBusGProxy* gui_get_remote (Gui* self) {
	DBusGProxy* result;
	g_return_val_if_fail (self != NULL, NULL);
	if (self->priv->_remote == NULL) {
		gui_dbus_init (self);
	}
	result = self->priv->_remote;
	return result;
}


static void gui_class_init (GuiClass * klass) {
	gui_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GuiPrivate));
	G_OBJECT_CLASS (klass)->get_property = gui_get_property;
	G_OBJECT_CLASS (klass)->finalize = gui_finalize;
}


static void gui_instance_init (Gui * self) {
	self->priv = GUI_GET_PRIVATE (self);
	self->priv->_remote = NULL;
}


static void gui_finalize (GObject* obj) {
	Gui * self;
	self = GUI (obj);
	_g_object_unref0 (self->priv->menu);
	_g_object_unref0 (self->priv->systraymenu);
	_g_object_unref0 (self->priv->top);
	_g_object_unref0 (self->priv->adddialog);
	_g_object_unref0 (self->priv->aboutdialog);
	_g_object_unref0 (self->priv->systray);
	_g_object_unref0 (self->priv->systraymenu_restore);
	_g_object_unref0 (self->priv->topvbox);
	_g_object_unref0 (self->priv->files);
	_g_object_unref0 (self->priv->auth_user);
	_g_object_unref0 (self->priv->auth_password);
	_g_object_unref0 (self->priv->port);
	_g_object_unref0 (self->priv->ssl);
	_g_object_unref0 (self->priv->redirection_type);
	_g_object_unref0 (self->priv->ssh_host);
	_g_object_unref0 (self->priv->ssh_port);
	_g_object_unref0 (self->priv->ssh_user);
	_g_object_unref0 (self->priv->ssh_password);
	_g_object_unref0 (self->priv->redirection_apply);
	_g_object_unref0 (self->priv->statusbar);
	_g_object_unref0 (self->priv->localdirectory);
	_g_object_unref0 (self->priv->shareas);
	_g_object_unref0 (self->priv->logtext);
	_g_object_unref0 (self->priv->clipboard);
	_g_object_unref0 (self->priv->model);
	_g_free0 (self->priv->string_model);
	_g_free0 (self->priv->public_url);
	_g_free0 (self->priv->preferred_share);
	_g_free0 (self->priv->invitation);
	_g_free0 (self->priv->display);
	_g_object_unref0 (self->priv->_remote);
	G_OBJECT_CLASS (gui_parent_class)->finalize (obj);
}


GType gui_get_type (void) {
	static volatile gsize gui_type_id__volatile = 0;
	if (g_once_init_enter (&gui_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GuiClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gui_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Gui), 0, (GInstanceInitFunc) gui_instance_init, NULL };
		GType gui_type_id;
		gui_type_id = g_type_register_static (G_TYPE_OBJECT, "Gui", &g_define_type_info, 0);
		g_once_init_leave (&gui_type_id__volatile, gui_type_id);
	}
	return gui_type_id__volatile;
}


static void gui_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Gui * self;
	self = GUI (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




